/*
    Test the loading of a module.
    Copyright (C) 2011  Made to Order Software Corp.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <iostream>
#include <dlfcn.h>

int main() {
    std::cout << "C++ dlopen demo" << std::endl << std::endl;

    // open the library
    std::cout << "Opening plugin.so..." << std::endl;
    void* handle = dlopen("./plugin.so", RTLD_LAZY);

    if (!handle) {
        std::cerr << "Cannot open plugin: " << dlerror() << std::endl;
        return 1;
    }

    // close the plugin
    std::cout << "Closing plugin..." << std::endl;
    dlclose(handle);
    std::cout << "PlugIn closed..." << std::endl;

    return 0;
}
